
#ifndef PASTWATCH_AQUASINGLE_H
#define PASTWATCH_AQUASINGLE_H

#include "sha1.h"
#include "bigint.h"
#include "dhash_common.h"
#include "pastdbfe.h"

static inline bigint
my_dbrec2id (ref<dbrec> d)
{
  assert (d->len == sha1::hashsize);
  bigint n;
  mpz_set_rawmag_be(&n, d->value, sha1::hashsize);
  return n;
}

class asrv;
class svccb;
class dhash_block;

struct dhash_insert_arg;
struct dhash_insert_res;
struct dhash_retrieve_res;

class aquasinglesrv : public virtual refcount
{
  ptr<asrv> clntsrv;
  void dispatch (svccb *sbp);
  void insert_to_localcache (chordID id, char* block,
                             int32_t len, dhash_ctype ctype);

public:
  aquasinglesrv (ptr<axprt_stream> x);
  ~aquasinglesrv ();
};

#endif

