#!/usr/bin/perl

$cvsroot = "redlab:/disk/ex0/sfscvs";
$module = "sfs1";
$base = "base";

# this script takes a CVS history and produces commands that can be
# used to generate diffs that correspond to that history.  you can
# generate history for this file to process with
#
# cvs -d $cvsroot history -D"date" -a -c | grep $module
#
# then crop the output at a specific date, if necessary.  you may need
# to change all references to EST in this file to the timezone of your
# choice.  this script also tries to ignore history related to files
# with X.X.X.X as revision number, because those are likely not on the
# main branch.

$lasta = 0;
$lastt;
$patch = 0;

while (<>) {
  if ($_ =~ / [\d]+\.[\d]+\.[\d]+\.[\d]+ /) { next; }
  $a = 0;
  $t;
  $timezone;
  if ($_ =~ /^M ([\d\s-]+):[\d]+ (\S+)\s/) {
    $a = 1;
    $t = $1;
    $timezone = $2;
  }
  elsif ($_ =~ /^A ([\d\s-]+):[\d]+ (\S+)\s/) {
    $a = 1;
    $t = $1;
    $timezone = $2;
  }
  elsif ($_ =~ /^R ([\d\s-]+):[\d]+ (\S+)\s/) {
    $a = 1;
    $t = $1;
    $timezone = $2;
  }
  if ($a == 1) {
    if ($lasta == 0) {
      print "cvs -d $cvsroot export -D\"$t:00 $timezone\" -d $base $module\n";
      $lastt = $t;
      $lasta = 1;
    }
    else {
      if (not $lastt eq $t) {
        print "cvs -R -d $cvsroot rdiff -c -D\"$lastt:00 $timezone\" -D\"$t:00 $timezone\" $module > patch-$patch\n";
        $lastt = $t;
	$patch++;
      }
    }
  }
}

