#!/usr/bin/perl -w

my $pastwatch = "pastwatch";

# Find relevant arguments for running CVS as a backup.
my $i=0;
my $cvs_command = "";
my $cvs_message = "";
my @cvs_files = ();
my $backup_cvsroot = $ENV{PASTWATCH_BACKUP_CVSROOT};

if ($backup_cvsroot) {
    my $cmd_idx = 0;
    my $x = "";

    for($i=0; $i<scalar(@ARGV); $i++) {
	if ($cvs_command eq "") {
	    if ($ARGV[$i] eq "commit") {
		$cvs_command = "commit";
		$cmd_idx = $i+1;
	    } elsif ($ARGV[$i] eq "add") {
		$cvs_command = "add";
		$cmd_idx = $i+1;
	    } elsif ($ARGV[$i] eq "remove") {
		$cvs_command = "remove";
		$cmd_idx = $i+1;
	    } elsif ($ARGV[$i] eq "rename") {
		$cvs_command = "rename";
		$cmd_idx = $i+1;
	    } 
	}
	if ($cvs_message eq "" && $ARGV[$i] eq "-m") {
	    if ($i+1 < scalar(@ARGV)) {
		$cvs_message = $ARGV[$i+1];
		$cmd_idx = $i+2;
	    }
	}
    }

    # get the list of files
    my $files_started = 0;
    for($i=$cmd_idx; $i<scalar(@ARGV); $i++) {
	#print "cmd_idx $cmd_idx $ARGV[$cmd_idx]\n";
	if ($cvs_command eq "commit") {
	    if ($ARGV[$i] eq "-j" || $ARGV[$i] eq "-S" ) {
		$i++;
		next;
	    } else {
		$files_started = 1;
	    }
	} elsif ($cvs_command eq "add") {
	    if ($ARGV[$i] eq "-S" ) {
		$i++;
		next;
	    } else {
		$files_started = 1;
	    }
	} elsif ($cvs_command eq "remove") {
	    if ($ARGV[$i] eq "-f" || $ARGV[$i] eq "-d") {
		next;
	    } else {
		$files_started = 1;
	    }
	} elsif ($cvs_command eq "rename") {
	    if ($ARGV[$i] eq "-S" ) {
		$i++;
		next;
	    } else {
		$files_started = 1;
	    }
	}
	if ($files_started) {
	    push @cvs_files, $ARGV[$i];
	}
    }

    #print "CVS command is $cvs_command\n";
    #print "CVS msg is \"$cvs_message\"\n";
    foreach $x (@cvs_files) {
	#print "CVS file: $x\n";
    }
}

my $r = system $pastwatch, @ARGV;

# Mirror command to CVS backup repository
if ($backup_cvsroot && $r == 0) {
    #print "Pastwatch returned $r\n";
    #my $files = join(" ", @cvs_files);

    if ($cvs_command eq "commit") {
	system("cvs", $cvs_command, "-m", "\"$cvs_message\"", @cvs_files);
    } elsif ($cvs_command eq "add" ||
	     $cvs_command eq "remove") {
	system("cvs", $cvs_command, @cvs_files);
    } elsif ($cvs_command eq "rename" && scalar(@cvs_files) == 2) {
	#if (-d $cvs_files[1]) {
	#    my @a = split (/\/+/, $cvs_files[0]);
	#    my $fname = $a[scalar(@a) - 1];
	#    $cvs_files[1] = "$cvs_files[1]/$fname";
	#}
	
	print "cvs rename $cvs_files[0] to $cvs_files[1]\n";

	system("cvs", "remove", $cvs_files[0]);
	system("cvs", "add", $cvs_files[1]);
	system("cvs", "commit", "-m", "\"$cvs_message\"", @cvs_files);
    }
}
